diff -ruN freeswan-1.9.orig/pluto/connections.c freeswan-1.9/pluto/connections.c
--- freeswan-1.9.orig/pluto/connections.c	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/connections.c	Wed May 16 11:41:27 2001
@@ -42,6 +42,11 @@
 #include "dnskey.h"	/* needs preshared.h */
 #include "whack.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#include "xmap.h"
+#endif
+
 static struct connection *connections = NULL;
 
 /* host_pair: a nexus of information about a pair of hosts.
@@ -296,6 +301,20 @@
     }
     unorient_connection(c);	/* won't delete c */
 
+#ifdef OPENSSL
+    if (c->cert != NULL) X509_free((X509 *)(c->cert));
+    if (c->key != NULL) EVP_PKEY_free((EVP_PKEY *)(c->key));
+    if (c->lu != NULL) sk_XMAP_pop_free(c->lu, XMAP_free);
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+       if (c->other[i].cert != NULL) {
+         X509_free((X509 *)(c->other[i].cert));
+        }
+    }
+#endif
+
     /* find and delete c from connections list */
     list_rm(struct connection, next, c, connections);
     cur_connection = old_cur_connection;
@@ -462,12 +481,61 @@
 static void
 unshare_connection_strings(struct connection *c)
 {
+#ifdef OPENSSL
+    void *tempcert, *tempkey;
+    STACK_OF(XMAP) *templu;
+#endif
     c->name = clone_str(c->name, "connection name");
 
     unshare_id_content(&c->this.id);
     c->this.updown = clone_str(c->this.updown, "updown");
     unshare_id_content(&c->that.id);
     c->that.updown = clone_str(c->that.updown, "updown");
+
+#ifdef OPENSSL
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+        if (c->other[i].cert) {
+          tempcert = c->other[i].cert;
+          c->other[i].cert = X509_dup(tempcert);
+        }
+    }
+
+
+    if (c->cert) {
+      tempcert = c->cert;
+      c->cert = X509_dup(tempcert);
+    }
+/* ******** HOW to use EVP_PKEY *************
+ * #define RSAPrivateKey_dup(rsa) (RSA *)ASN1_dup((int (*)())i2d_RSAPrivateKey,
+ *                (char *(*)())d2i_RSAPrivateKey,(char *)rsa)
+ * /usr/include/openssl/evp.h:621:RSA *  EVP_PKEY_get1_RSA(EVP_PKEY *pkey);
+ *
+ * DEFS:
+ * /usr/include/openssl/evp.h:637:EVP_PKEY *  d2i_PrivateKey(int type,
+ *               EVP_PKEY **a, unsigned char **pp,
+ * /usr/include/openssl/evp.h:641:int  i2d_PrivateKey(EVP_PKEY *a,
+ *               unsigned char **pp);
+ * X509 dup macro:
+ * #define X509_dup(x509) (X509 *)ASN1_dup((int (*)())i2d_X509, \
+ *                 (char *(*)())d2i_X509,(char *)x509)
+ * NEW MACRO:
+ * #define EVP_PKEY_dup(pkey) \
+ *   (EVP_PKEY *)ASN1_dup((int (*)())i2d_PrivateKey, \
+ *   (char *(*)())d2i_AutoPrivateKey,(char *)pkey)
+ */
+
+    if (c->key) {
+      tempkey = c->key;
+      c->key = EVP_PKEY_dup(tempkey);
+    }
+    if (c->lu) {
+      templu = c->lu;
+      c->lu = clone_sk_XMAP(templu);
+    }
+#endif
 }
 
 static void
@@ -537,7 +605,11 @@
 
 	    for (; c != NULL; c = c->hp_next)
 	    {
+#ifndef OPENSSL
 		if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_RSASIG))
+#else
+		if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_OPENSSL))
+#endif
 		{
 		    loglog(RC_CLASH
 			, "authentication method disagrees with \"%s\", which is also for an unspecified peer"
@@ -553,6 +625,8 @@
 void
 add_connection(const struct whack_message *wm)
 {
+    bool success = TRUE;
+
     if (con_by_name(wm->name, FALSE) != NULL)
     {
 	loglog(RC_DUPNAME, "attempt to redefine connection \"%s\"", wm->name);
@@ -577,6 +651,15 @@
 	c->sa_rekey_fuzz = wm->sa_rekey_fuzz;
 	c->sa_keying_tries = wm->sa_keying_tries;
 
+	c->block_cypher = wm->block_cypher;
+
+#ifdef OPENSSL
+	c->this.id.key_id.len = 0;
+	c->that.id.key_id.len = 0;
+	c->this.id.der_asn1_dn.len = 0;
+	c->that.id.der_asn1_dn.len = 0;
+#endif
+
 	c->addr_family = wm->addr_family;
 	c->tunnel_addr_family = wm->tunnel_addr_family;
 
@@ -595,6 +678,35 @@
 	    c->that = t;
 	}
 
+#ifdef OPENSSL
+	{
+	    int i;
+
+	    for(i=0; i<MAX_OTHER; i++) {
+	      c->other[i].cert = NULL;
+	      c->other[i].type = 0;
+	    }
+	}
+	load_cert_and_key(wm->whack_certfile, wm->whack_keyfile,
+	    (X509 **)&(c->cert), (EVP_PKEY **)&(c->key));
+	c->cert_options = parse_options(wm->whack_certopts);
+
+#if 0 /* to be removed? */
+	/* ID_DER_ASN1_DN cannot be done with path=db or path=dir */
+	if (! check_idtype_and_path(c, wm->whack_certpath)) {
+	  success = FALSE;
+	}
+#endif
+
+       if (! make_lookups((STACK_OF(XMAP) **)(&(c->lu)),
+         wm->whack_certpath) ) {
+         success = FALSE;
+       }
+       strncpy(c->path, wm->whack_certpath, PATH_NAME_LIMIT);
+#endif
+
+
+
 	/* set internal fields */
 	c->next = connections;
 	connections = c;
@@ -618,9 +730,10 @@
 
 	possibly_some_oppo = TRUE;	/* could be more careful about this */
 
-	/* log all about this connection */
-	log("added connection description \"%s\"", c->name);
-	DBG(DBG_CONTROL,
+	/* log all about this connection, if sucessful */
+	if (success) {
+	  log("added connection description \"%s\"", c->name);
+	  DBG(DBG_CONTROL,
 	    char lhs[SUBNETTOT_BUF + ADDRTOT_BUF + IDTOA_BUF + ADDRTOT_BUF];
 	    char rhs[SUBNETTOT_BUF + ADDRTOT_BUF + IDTOA_BUF + ADDRTOT_BUF];
 
@@ -650,7 +763,16 @@
 		, (unsigned long) c->sa_rekey_fuzz
 		, (unsigned long) c->sa_keying_tries
 		, bitnamesof(sa_policy_bit_names, c->policy));
-	);
+	  );
+	} else {
+	  loglog(RC_LOG_SERIOUS,
+	    "Adding connection description \"%s\" failed.",
+	    c->name);
+	  loglog(RC_LOG_SERIOUS,
+	    "Deleting connection description \"%s\".",
+	    c->name);
+	  delete_connection(c);
+	}
     }
 }
 
@@ -1205,7 +1327,13 @@
 	    return NULL;	/* cannot determine PSK! */
 	break;
     case OAKLEY_RSA_SIG:
+#ifndef OPENSSL
 	auth_policy = POLICY_RSASIG;
+#else
+   case OAKLEY_RSA_ENC:
+   case OAKLEY_RSA_ENC_REV:
+	auth_policy = POLICY_OPENSSL;
+#endif
 	my_RSA_pri = get_RSA_private_key(c);
 	if (my_RSA_pri == NULL)
 	    return NULL;	/* cannot determine my RSA private key! */
@@ -1216,6 +1344,14 @@
 		return NULL;	/* cannot determine his RSA public key! */
 	}
 	break;
+#ifdef OPENSSL
+    case OAKLEY_DSS_SIG:
+    case OAKLEY_ELGAMAL_ENC:
+    case OAKLEY_ELGAMAL_ENC_REV:
+	auth_policy = POLICY_OPENSSL;
+	/* Not implemented yet */
+	break;
+#endif
     default:
 	passert(FALSE);
     }
@@ -1235,6 +1371,28 @@
 	    if (!oriented(*d))
 		(void)orient(d, FALSE);
 
+#ifdef OPENSSL
+           /* fetch d's other cert, when applicable. */
+             if (auth_policy == POLICY_OPENSSL) {
+               bool r;
+               switch(auth) {
+                 case OAKLEY_RSA_SIG:
+                 case OAKLEY_RSA_ENC:
+                 case OAKLEY_RSA_ENC_REV:
+                   r = have_othercert(d, EVP_PKEY_RSA);
+                   break;
+
+                  case OAKLEY_DSS_SIG:
+                 case OAKLEY_ELGAMAL_ENC:
+                 case OAKLEY_ELGAMAL_ENC_REV:
+                   r = have_othercert(d, EVP_PKEY_DSA);
+                   break;
+               default:
+                   passert(FALSE);
+               } /* END switch */
+             }
+#endif
+
 	    if (!same_id(&c->this.id, &d->this.id))
 		continue;
 
@@ -1273,8 +1431,39 @@
 			 * so we must be sure that any connection we
 			 * select will use the same public key.
 			 */
-			const struct RSA_public_key *hnk = exact
-			    ? get_his_RSA_public_key(d) : get_RSA_public_key(peer_id);
+			const struct RSA_public_key *hnk;
+#ifdef OPENSSL
+		      if (!use_openssl(st->st_connection)) {
+#endif
+			hnk = exact ? get_his_RSA_public_key(d) 
+			  : get_RSA_public_key(peer_id);
+#ifdef OPENSSL
+		      } else {
+		        hnk = exact ? get_his_RSA_public_key(d) 
+		          : fs_RSA(X509_get_pubkey((X509 *)d->other));
+		      }
+#endif
+			passert(exact || d->gw_info == NULL);
+
+			if (!same_RSA_public_key(his_RSA_pub, hnk))
+			    continue;	/* different public key */
+		    }
+		    break;
+#ifdef OPENSSL
+		case OAKLEY_RSA_ENC:
+		case OAKLEY_RSA_ENC_REV:
+		    if (my_RSA_pri != get_RSA_private_key(d))
+			continue;	/* different private key */
+
+		    if (initiator)
+		    {
+			/* his public key has been used for authentication
+			 * so we must be sure that any connection we
+			 * select will use the same public key.
+			 */
+		        const struct RSA_public_key *hnk = exact
+		          ? get_his_RSA_public_key(d) 
+		          : fs_RSA(X509_get_pubkey((X509 *)d->other));
 
 			passert(exact || d->gw_info == NULL);
 
@@ -1282,6 +1471,7 @@
 			    continue;	/* different public key */
 		    }
 		    break;
+#endif
 		default:
 		    passert(FALSE);
 		}
diff -ruN freeswan-1.9.orig/pluto/connections.h freeswan-1.9/pluto/connections.h
--- freeswan-1.9.orig/pluto/connections.h	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/connections.h	Wed May 16 10:57:20 2001
@@ -14,6 +14,10 @@
  * RCSID $Id: connections.h,v 1.43 2001/01/28 21:03:02 dhr Exp $
  */
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+
 /* There are two kinds of connections:
  * - ISAKMP connections, between hosts (for IKE communication)
  * - IPsec connections, between clients (for secure IP communication)
@@ -78,6 +82,13 @@
  * the old one.  It is deleted when no longer in use.
  */
 
+#ifdef OPENSSL
+struct other_st {
+  u_int32_t type; /* type of certificate in 'cert': EVP_PKEY_RSA or EVP_PKEY_DSA */
+  void *cert;
+};
+#endif
+
 struct end {
     struct id id;
     ip_address
@@ -92,6 +103,20 @@
 
 struct connection {
     char *name;
+#ifdef OPENSSL
+    /* The declaration of these as void is truly horrific - they 
+     * should be X509 and EVP_PKEY pointers. Unfortunately, if this
+     * is declared, the MD5 header files from OpenSSL conflict with those
+     * in the KLIPS source. Hence we cast these pointers to the right
+     * type at the time of use. It's disgusting, but I can't think of
+     * another way -- ND 
+     */
+    void *cert, *key, *lu;
+    struct other_st other[MAX_OTHER];
+    u_char path[PATH_NAME_LIMIT];
+    u_int32_t cert_options;
+#endif
+    lset_t block_cypher;
     lset_t policy;
     time_t sa_ike_life_seconds;
     time_t sa_ipsec_life_seconds;
diff -ruN freeswan-1.9.orig/pluto/constants.c freeswan-1.9/pluto/constants.c
--- freeswan-1.9.orig/pluto/constants.c	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/constants.c	Wed May 16 10:57:20 2001
@@ -283,13 +283,38 @@
 enum_names ident_names =
     { ID_IPV4_ADDR, ID_KEY_ID, ident_name, NULL };
 
+#ifdef OPENSSL
+/* Certificate type values */
+static const char *const cert_name[] = {
+       "CERT_TYPE_NONE",
+       "CERT_TYPE_PKCS7",
+       "CERT_TYPE_PGP",
+       "CERT_TYPE_DNSKEY",
+       "CERT_TYPE_X509_SIG",
+       "CERT_TYPE_X509_KEX",
+       "CERT_TYPE_KERBEROS",
+       "CERT_TYPE_CRL",
+       "CERT_TYPE_ARL",
+       "CERT_TYPE_SPKI",
+       "CERT_TYPE_X509_ATTR",
+    };
+
+enum_names cert_names =
+    { CERT_TYPE_NONE, CERT_TYPE_X509_ATTR, cert_name, NULL };
+#endif
+
+
 /* Goal BITs for establishing an SA
  * Note: we drop the POLICY_ prefix so that logs are more concise.
  */
 
 const char *const sa_policy_bit_names[] = {
 	"PSK",
+#ifndef OPENSSL
 	"RSASIG",
+#else
+	"OPENSSL",
+#endif
 	"ENCRYPT",
 	"AUTHENTICATE",
 	"COMPRESS",
diff -ruN freeswan-1.9.orig/pluto/constants.h freeswan-1.9/pluto/constants.h
--- freeswan-1.9.orig/pluto/constants.h	Sun Jan 28 16:03:03 2001
+++ freeswan-1.9/pluto/constants.h	Wed May 16 10:57:20 2001
@@ -460,17 +460,45 @@
 #define ID_DER_ASN1_GN              10
 #define ID_KEY_ID                   11
 
+#ifdef OPENSSL
+#define CERT_OPTION_SEND           0x01
+#define CERT_OPTION_PKCS7          0x02
+#define CERT_OPTION_PK             0x04
+#define CERT_OPTION_REV            0x08
+#define CERT_OPTION_STRICT         0x10
+#define CERT_OPTION_DSS_SHA        0x20
+#define CERT_OPTION_DSS_ALT        0x40
+
+extern enum_names cert_names;
+
+#define CERT_TYPE_NONE              0
+#define CERT_TYPE_PKCS7             1
+#define CERT_TYPE_PGP               2
+#define CERT_TYPE_DNSKEY            3
+#define CERT_TYPE_X509_SIG          4
+#define CERT_TYPE_X509_KEX          5
+#define CERT_TYPE_KERBEROS          6
+#define CERT_TYPE_CRL               7
+#define CERT_TYPE_ARL               8
+#define CERT_TYPE_SPKI              9
+#define CERT_TYPE_X509_ATTR        10
+#endif
+
 /* Policies for establishing an SA
  *
  * These are used to specify attributes (eg. encryption) and techniques for
- * (eg PFS) required of an SA.  POLICY_PSK and POLICY_RSASIG are for
+ * (eg PFS) required of an SA.  POLICY_PSK and POLICY_RSASIG/OPENSSL are for
  * ISAKMP SAs; the rest are about IPsec SAs
  */
 
 extern const char *const sa_policy_bit_names[];
 
 #define POLICY_PSK           LELEM(0)
+#ifndef OPENSSL
 #define POLICY_RSASIG        LELEM(1)
+#else
+#define POLICY_OPENSSL        LELEM(1)
+#endif
 
 #define POLICY_ENCRYPT       LELEM(2)
 #define POLICY_AUTHENTICATE  LELEM(3)
@@ -479,7 +507,11 @@
 #define POLICY_PFS           LELEM(6)
 
 #define POLICY_ISAKMP_SHIFT	0	/* log2(POLICY_PSK) */
+#ifndef OPENSSL
 #define POLICY_ISAKMP_MASK	(POLICY_PSK | POLICY_RSASIG)
+#else
+#define POLICY_ISAKMP_MASK	(POLICY_PSK | POLICY_OPENSSL)
+#endif
 #define POLICY_IPSEC_SHIFT	2	/* log2(POLICY_ENCRYPT) */
 
 /* Oakley transform attributes
@@ -547,6 +579,12 @@
 #define SA_REPLACEMENT_RETRIES_DEFAULT	    3	/*  (IPSEC & IKE) */
 
 #define SA_LIFE_DURATION_K_DEFAULT  0xFFFFFFFFlu
+
+/* DES support */
+#define ALL_BLOCK_CYPHER 1
+#define DES_BLOCK_CYPHER 2
+#define DES3_BLOCK_CYPHER 3
+#define FORCE_ENCRYPT_CYPHER_DEFAULT ALL_BLOCK_CYPHER
 
 /* Encapsulation Mode attribute */
 
diff -ruN freeswan-1.9.orig/pluto/cookie.c freeswan-1.9/pluto/cookie.c
--- freeswan-1.9.orig/pluto/cookie.c	Wed Oct 25 20:58:05 2000
+++ freeswan-1.9/pluto/cookie.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: cookie.c,v 1.13 2000/10/26 00:58:05 dhr Exp $
+ * RCSID $Id: cookie.c,v 1.14 2001/03/13 09:22:03 dhr Exp $
  */
 
 #include <stdio.h>
@@ -20,6 +20,8 @@
 #include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
+
+#include <freeswan.h>
 
 #include "constants.h"
 #include "defs.h"
diff -ruN freeswan-1.9.orig/pluto/crypto.h freeswan-1.9/pluto/crypto.h
--- freeswan-1.9.orig/pluto/crypto.h	Sun Dec 12 19:40:50 1999
+++ freeswan-1.9/pluto/crypto.h	Wed May 16 10:57:20 2001
@@ -56,7 +56,11 @@
 /* unification of cryptographic hashing mechanisms */
 
 union hash_ctx {
+#ifndef OPENSSL
 	MD5_CTX ctx_md5;
+#else
+	PLUTO_MD5_CTX ctx_md5;
+#endif
 	SHA1_CTX ctx_sha1;
     };
 
diff -ruN freeswan-1.9.orig/pluto/defs.c freeswan-1.9/pluto/defs.c
--- freeswan-1.9.orig/pluto/defs.c	Wed Oct 25 18:05:02 2000
+++ freeswan-1.9/pluto/defs.c	Wed May 16 10:57:20 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: defs.c,v 1.17 2000/10/25 22:05:02 dhr Exp $
+ * RCSID $Id: defs.c,v 1.18 2001/03/13 09:22:03 dhr Exp $
  */
 
 #include <stdlib.h>
@@ -19,9 +19,13 @@
 #include <stdio.h>
 #include <sys/types.h>
 
+#include <freeswan.h>
+
 #include "constants.h"
 #include "defs.h"
 #include "log.h"
+#include "id.h"
+#include "connections.h" /* needs id.h */
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
 const chunk_t empty_chunk = { NULL, 0 };
diff -ruN freeswan-1.9.orig/pluto/defs.h freeswan-1.9/pluto/defs.h
--- freeswan-1.9.orig/pluto/defs.h	Wed Oct 25 18:05:02 2000
+++ freeswan-1.9/pluto/defs.h	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: defs.h,v 1.24 2000/10/25 22:05:02 dhr Exp $
+ * RCSID $Id: defs.h,v 1.26 2001/05/08 05:37:21 dhr Exp $
  */
 
 /* GCC magic! */
@@ -37,8 +37,8 @@
  * Needed in connections.h and state.h; here to simplify dependencies.
  */
 typedef unsigned long so_serial_t;
-#define SOS_NOBODY  0	/* null serial number */
-
+#define SOS_NOBODY	0	/* null serial number */
+#define SOS_FIRST	1	/* first normal serial number */
 
 /* memory allocation */
 
@@ -59,6 +59,22 @@
 #define pfreeany(p) { if ((p) != NULL) pfree(p); }
 #define replace(p, q) { pfreeany(p); (p) = (q); }
 
+#ifdef OPENSSL
+#include <des.h>
+
+typedef union _keysched_u {
+  struct _des3_ks { des_key_schedule ks[3]; } des3_ks;
+
+#if 0 /* *Please* don't define this - you *really* don't want single DES */
+  des_key_schedule des_ks;
+#endif
+
+#ifdef NOTYET
+  /* Other ciphers, eg CAST, RC5, etc... */
+#endif
+
+} keysched;
+#endif
 
 /* chunk is a simple pointer-and-size abstraction */
 
@@ -83,6 +99,9 @@
 extern void exit_pluto(int /*status*/) NEVER_RETURNS;
 
 
+/* zero all bytes */
+#define zero(x) memset((x), '\0', sizeof(*(x)))
+
 /* are all bytes 0? */
 extern bool all_zero(const unsigned char *m, size_t len);
 
@@ -105,3 +124,31 @@
 
 /* pad_up(n, m) is the amount to add to n to make it a multiple of m */
 #define pad_up(n, m) (((m) - 1) - (((n) + (m) - 1) % (m)))
+
+/* writemem_short adds support to write to unaligned memory (arm). */
+#ifdef __arm__
+#define writemem_u_int16_t(addr, offset, n) do {\
+  u_int16_t temp16 = htons((n)); \
+  (addr)[(offset)] = temp16 & 0xff; \
+  (addr)[(offset)+1] = temp16 >> 8; \
+} while (0)
+#else
+#define writemem_u_int16_t(addr, offset, n) do {\
+  *((u_int16_t *)(&((addr)[(offset)]))) = htons((n)); \
+} while (0)
+#endif
+
+/* readmem_short adds support to read from unaligned memory (arm). */
+#ifdef __arm__
+#define readmem_u_int16_t(addr, offset, var) do {\
+  u_int16_t temp16 = 0; \
+  temp16 += *((u_int8_t *)(&((addr)[(offset)]))) << 8; \
+  temp16 += *((u_int8_t *)(&((addr)[(offset)+1]))); \
+  (var) = temp16; \
+} while (0)
+#else
+#define readmem_u_int16_t(addr, offset, var) do {\
+  u_int16_t temp16 = ntohs(*((u_int16_t *)(&((addr)[(offset)])))); \
+  (var) = temp16; \
+} while (0)
+#endif
